package estella.gui;
import javax.swing.*;
import estella.lib.*;
import estella.cliente.*;

import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;
import java.util.StringTokenizer;
import java.util.*;

/**
* Interface grafica
* @author Renato Demarco - Cesar Kallas
*/
public class JanelaPrincipal extends Cliente implements Runnable {
	
	public javax.swing.JFrame jFrame;
	private Constantes CON;
	private Log LOG;
  private Tempo TEMPO;
  private StringTokenizer preServents;
	private Payload payload;
	private Descritor descritor;
	private Thread t_recebeDescritores;
	private Repositorio repositorio;
	public static Vector 
		linhaTabelaServents, 
		linhaTabelaServentsOnline, 
		linhaTabelaBusca, 
		linhaTabelaDownload, 
		linhaTabelaUpload,
		linhaTabelaArquivosCompartilhados;
	
	public static Vector 
		colunaTabelaServents, 
		colunaTabelaServentsOnline, 
		colunaTabelaBusca, 
		colunaTabelaDownload, 
		colunaTabelaUpload,
		colunaTabelaArquivosCompartilhados;
		
    /** Creates new form JanelaPrincipal */
    public JanelaPrincipal() {
			initComponents();
			LOG = new Log("Cliente");
			CON = new Constantes();
			TEMPO = new Tempo();
			
			repositorio = new Repositorio();
			repositorio.gera();
			
			if(carregaServents(CON.LISTA_SERVENTS))
				LOG.info("Servents carregados com sucesso!");
			else
				LOG.falha(" ao carregar servents!");
			jFrame.setVisible(true);
			
			Dados.offlineServents.atualizaTabelaServents();
    }

		public void sair()
		{
			LOG.fecha();
		}
    
		public void run()
		{
		}
		
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
				linhaTabelaServents = new Vector();
				colunaTabelaServents = new Vector();
				
				linhaTabelaServentsOnline = new Vector();
				colunaTabelaServentsOnline = new Vector();
			
				linhaTabelaDownload = new Vector();
				colunaTabelaDownload = new Vector();
				colunaTabelaDownload.addElement("Arquivo");
				colunaTabelaDownload.addElement("Tamanho (Bytes)");
				colunaTabelaDownload.addElement("Index");
				colunaTabelaDownload.addElement("Servent");
				colunaTabelaDownload.addElement("Porta");
			
				linhaTabelaUpload = new Vector();
				colunaTabelaUpload = colunaTabelaDownload;
			
				linhaTabelaBusca = new Vector();
				colunaTabelaBusca = new Vector();
				colunaTabelaBusca.addElement("Nome");
				colunaTabelaBusca.addElement("Tamanho (Bytes)");
				colunaTabelaBusca.addElement("Index");
				colunaTabelaBusca.addElement("Servent");
				colunaTabelaBusca.addElement("Porta");
			
				colunaTabelaServents.addElement("Servent");
				colunaTabelaServents.addElement("Porta");
				colunaTabelaServents.addElement("N. Arq. Comp.");
				colunaTabelaServents.addElement("Tam. Arq. Comp. (Bytes)");
				colunaTabelaServentsOnline = colunaTabelaServents;
				
				linhaTabelaArquivosCompartilhados = new Vector();
				colunaTabelaArquivosCompartilhados = new Vector();
				colunaTabelaArquivosCompartilhados.addElement("Nome");
				colunaTabelaArquivosCompartilhados.addElement("Tamanho (Bytes)");
				colunaTabelaArquivosCompartilhados.addElement("Index");
			
				jFrame = new javax.swing.JFrame();
        painelTabs = new javax.swing.JTabbedPane();
        tabServents = new javax.swing.JTabbedPane();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        tabelaServentsOnline = new javax.swing.JTable();
        botaoConectaServent = new javax.swing.JButton();
        textPorta = new javax.swing.JTextField();
        textIp = new javax.swing.JTextField();
        botaoDesconectar = new javax.swing.JButton();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        tabelaServents = new javax.swing.JTable();
        botaoAumentarRede = new javax.swing.JButton();
        botaoConectar = new javax.swing.JButton();
        tabBusca = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        botaoBusca = new javax.swing.JButton();
        textBusca = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        tabelaBusca = new javax.swing.JTable();
        tabTransferencias = new javax.swing.JTabbedPane();
        tabelaDownloads = new javax.swing.JScrollPane();
        tabelaDownload = new javax.swing.JTable();
        jScrollPane5 = new javax.swing.JScrollPane();
        tabelaUploads = new javax.swing.JTable();
        tabArquivosCompartilhados = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        tabelaArquivosCompartilhados = new javax.swing.JTable();
        botaoAtualizarTabelaArquivos = new javax.swing.JButton();
        tabLog = new javax.swing.JTabbedPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        textAreaLog = new javax.swing.JTextArea();
        tabSobre = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        botaoSair = new javax.swing.JButton();
        labelServentsOnline = new javax.swing.JLabel();
        labelTransferencias = new javax.swing.JLabel();
        labelOnline = new javax.swing.JLabel();
        labelArqComp = new javax.swing.JLabel();
        menu = new javax.swing.JMenuBar();
        menu_Opcoes = new javax.swing.JMenu();
        menuConectar = new javax.swing.JMenuItem();
        menuDesconectar = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        menuSair = new javax.swing.JMenuItem();

        jFrame.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jFrame.setTitle("Estella - Gnutella Cliente 0.4");
        jFrame.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jFrame.setLocationByPlatform(true);
				jFrame.setResizable(false);
        painelTabs.setBackground(new java.awt.Color(204, 255, 204));
        painelTabs.setToolTipText("Painel de navega\u00e7\u00e3o");
        painelTabs.setName("tab");
        tabServents.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        tabServents.setToolTipText("Servents");
        tabServents.setName("tabServents");
        jPanel7.setToolTipText("Servents Online");
        tabelaServentsOnline.setModel(new javax.swing.table.DefaultTableModel(linhaTabelaServentsOnline, colunaTabelaServentsOnline));
        tabelaServentsOnline.setToolTipText("Servent online (conectados)");
        jScrollPane3.setViewportView(tabelaServentsOnline);

        botaoConectaServent.setText("Conecta");
        botaoConectaServent.setToolTipText("Conecta no servent");
        botaoConectaServent.setName("botaoConectaServent");
        botaoConectaServent.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                botaoConectaServentKeyPressed(evt);
            }
        });
        botaoConectaServent.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoConectaServentMouseClicked(evt);
            }
        });

        textPorta.setFont(new java.awt.Font("Dialog", 1, 12));
        textPorta.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        textPorta.setBorder(javax.swing.BorderFactory.createTitledBorder("Porta"));
        textPorta.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                textPortaKeyTyped(evt);
            }
        });

        textIp.setFont(new java.awt.Font("Dialog", 1, 12));
        textIp.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        textIp.setBorder(javax.swing.BorderFactory.createTitledBorder("Servent"));

        botaoDesconectar.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/connect_creating.png")));
        botaoDesconectar.setToolTipText("Desconectar");
        botaoDesconectar.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                botaoDesconectarKeyPressed(evt);
            }
        });
        botaoDesconectar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoDesconectarMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel7Layout = new org.jdesktop.layout.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel7Layout.createSequentialGroup()
                        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 565, Short.MAX_VALUE)
                        .add(12, 12, 12))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel7Layout.createSequentialGroup()
                        .add(botaoDesconectar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 66, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 161, Short.MAX_VALUE)
                        .add(textIp, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 161, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(textPorta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botaoConectaServent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 93, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 204, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel7Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(textPorta, 0, 0, Short.MAX_VALUE)
                        .add(textIp, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(botaoDesconectar)
                    .add(botaoConectaServent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        tabServents.addTab("Online", new javax.swing.ImageIcon(""), jPanel7);

        jScrollPane4.setToolTipText("Servents offline");
        tabelaServents.setModel(new javax.swing.table.DefaultTableModel(linhaTabelaServents, colunaTabelaServents));
        tabelaServents.setToolTipText("Servents offline");
        jScrollPane4.setViewportView(tabelaServents);

        botaoAumentarRede.setText("Procurar novos servents");
        botaoAumentarRede.setToolTipText("Procura automaticamente novos servents");
        botaoAumentarRede.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                botaoAumentarRedeKeyPressed(evt);
            }
        });
        botaoAumentarRede.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoAumentarRedeMouseClicked(evt);
            }
        });

        botaoConectar.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/connect_no.png")));
        botaoConectar.setToolTipText("Conectar");
        botaoConectar.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                botaoConectarKeyPressed(evt);
            }
        });
        botaoConectar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoConectarMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel8Layout = new org.jdesktop.layout.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane4, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 565, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel8Layout.createSequentialGroup()
                        .add(botaoConectar)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 315, Short.MAX_VALUE)
                        .add(botaoAumentarRede)))
                .addContainerGap())
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 213, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel8Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(botaoConectar)
                    .add(botaoAumentarRede))
                .addContainerGap())
        );
        tabServents.addTab("Offline", jPanel8);

        painelTabs.addTab("Servents", new javax.swing.ImageIcon(getClass().getResource("icones/network.png")), tabServents);

        botaoBusca.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/findf.png")));
        botaoBusca.setText("Buscar");
        botaoBusca.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                botaoBuscaKeyPressed(evt);
            }
        });
        botaoBusca.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoBuscaMouseClicked(evt);
            }
        });

        textBusca.setToolTipText("Digite o texto que deseja pesquisar");
        textBusca.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                textBuscaKeyTyped(evt);
            }
        });

        tabelaBusca.setModel(new javax.swing.table.DefaultTableModel(linhaTabelaBusca, colunaTabelaBusca));
        tabelaBusca.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tabelaBuscaMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(tabelaBusca);

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 565, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                        .add(textBusca, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 464, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botaoBusca)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, textBusca)
                    .add(botaoBusca, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                .addContainerGap())
        );
        tabBusca.addTab("Busca Online", jPanel2);

        painelTabs.addTab("Busca", new javax.swing.ImageIcon(getClass().getResource("icones/findf.png")), tabBusca);

        tabTransferencias.setToolTipText("Transfer\u00eancias ativas");
        tabTransferencias.setName("tabTransferencias");
        tabelaDownload.setModel(new javax.swing.table.DefaultTableModel(linhaTabelaDownload, colunaTabelaDownload));
        tabelaDownload.setToolTipText("Transfer\u00eancias ativas - download");
        tabelaDownloads.setViewportView(tabelaDownload);

        tabTransferencias.addTab("Download", tabelaDownloads);
        tabelaUploads.setModel(new javax.swing.table.DefaultTableModel(linhaTabelaUpload, colunaTabelaUpload));
        tabelaUploads.setToolTipText("Transfer\u00eancias ativas - upload");
        jScrollPane5.setViewportView(tabelaUploads);

        tabTransferencias.addTab("Upload", jScrollPane5);

        painelTabs.addTab("Transfer\u00eancias", new javax.swing.ImageIcon(getClass().getResource("icones/agt_update_misc.png")), tabTransferencias);

        tabArquivosCompartilhados.setToolTipText("Arquivos compartilhados");
        tabelaArquivosCompartilhados.setModel(new javax.swing.table.DefaultTableModel(linhaTabelaArquivosCompartilhados, colunaTabelaArquivosCompartilhados));
        jScrollPane6.setViewportView(tabelaArquivosCompartilhados);

        botaoAtualizarTabelaArquivos.setText("Atualizar");
        botaoAtualizarTabelaArquivos.setToolTipText("Atualiza tabela de arquivos compartilhados");
        botaoAtualizarTabelaArquivos.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                botaoAtualizarTabelaArquivosKeyPressed(evt);
            }
        });
        botaoAtualizarTabelaArquivos.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoAtualizarTabelaArquivosMouseClicked(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 565, Short.MAX_VALUE)
                    .add(botaoAtualizarTabelaArquivos))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 228, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(botaoAtualizarTabelaArquivos)
                .addContainerGap())
        );
        tabArquivosCompartilhados.addTab("Arquivos compartilhados", new javax.swing.ImageIcon(""), jPanel3, "Arquivos compartilhados para a rede gnutella");

        painelTabs.addTab("Arquivos Compartilhados", new javax.swing.ImageIcon(getClass().getResource("icones/fileshare.png")), tabArquivosCompartilhados, "Arquivos compartilhados para a rede");

        tabLog.setToolTipText("Log");
        tabLog.setName("tabLog");
        textAreaLog.setColumns(20);
        textAreaLog.setEditable(false);
        textAreaLog.setRows(15);
        textAreaLog.setToolTipText("Log do sistema");
        jScrollPane2.setViewportView(textAreaLog);

        tabLog.addTab("Log do Sistema", jScrollPane2);

        painelTabs.addTab("Log", new javax.swing.ImageIcon(getClass().getResource("icones/news_subscribe.png")), tabLog);

        tabSobre.setToolTipText("Sobre");
        tabSobre.setName("Sobre");
        jPanel1.setToolTipText("Sobre");
        jLabel1.setFont(new java.awt.Font("Arial Black", 1, 24));
        jLabel1.setForeground(new java.awt.Color(0, 51, 102));
        jLabel1.setText("Estella v.0.1 - Gnutella Cliente");

        jLabel2.setText("Desenvolvedores");

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/sharemanager.png")));

        jLabel4.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel4.setText("C\u00e9sar Kallas - cesarkallas at gmx . net - http://cesarkallas.soulivre.org");

        jLabel5.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel5.setText("Daniel Machado - daniel.fm at uol . com . br");

        jLabel6.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel6.setText("F\u00e1bio Generoso - fgeneroso at hotmail . com");

        jLabel7.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel7.setText("Renato Demarco - renatodemarco at gmail . com");

        jLabel8.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/logo_puc_color_100px.gif")));

        jLabel9.setText("Pontif\u00edcia Universidade Cat\u00f3lica - Campinas - Brasil");

        jLabel10.setText("2005");

        jLabel11.setText("Redes de Computadores 1");

        jLabel12.setFont(new java.awt.Font("Dialog", 1, 10));
        jLabel12.setText("Professor Juan Manueal A. Coelho - juan@puc-campinas.edu.br");

        jLabel13.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/penglogo_thumb.jpg")));

        jLabel14.setFont(new java.awt.Font("Dialog", 0, 10));
        jLabel14.setText("Baseado na especifica\u00e7\u00e3o 0.4 - http://rfc-gnutella.sourceforge.net");

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel1)
                            .add(jLabel2)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                                .add(12, 12, 12)
                                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(jLabel5)
                                    .add(jLabel4)
                                    .add(jLabel6)
                                    .add(jLabel7))))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel3))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(jLabel9)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel10))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jLabel8)
                    .add(jLabel14)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel11)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                                .add(12, 12, 12)
                                .add(jLabel12)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 132, Short.MAX_VALUE)
                        .add(jLabel13)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel3)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel5)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel6)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel7)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel11)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(42, 42, 42)
                        .add(jLabel8))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel13)
                            .add(jLabel12))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel14)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel9)
                    .add(jLabel10))
                .add(58, 58, 58))
        );
        tabSobre.addTab("Estella v. 0.1", jPanel1);

        painelTabs.addTab("Sobre", new javax.swing.ImageIcon(getClass().getResource("icones/attach.png")), tabSobre);

        botaoSair.setIcon(new javax.swing.ImageIcon(getClass().getResource("icones/exit.png")));
        botaoSair.setToolTipText("Sair");
        botaoSair.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoSairMouseClicked(evt);
            }
        });

        labelServentsOnline.setText("0");
        labelServentsOnline.setToolTipText("N\u00famero de servents que voc\u00ea est\u00e1 conectado");
        labelServentsOnline.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Servents Online", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 10)));

        labelTransferencias.setText("0/0");
        labelTransferencias.setToolTipText("Transfer\u00eancias ativas");
        labelTransferencias.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Transf. (down/up)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 10)));

        labelOnline.setText("n\u00e3o");
        labelOnline.setToolTipText("Online ?");
        labelOnline.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Online", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 10)));

        labelArqComp.setFont(new java.awt.Font("Dialog", 0, 10));
        labelArqComp.setText("0/0(mb)");
        labelArqComp.setToolTipText("Arquivos compartilhados (n\u00famero / tamanho total)");
        labelArqComp.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Arq. Comp.", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 1, 10)));

        menu_Opcoes.setText("Op\u00e7\u00f5es");
        menuConectar.setText("Conectar");
        menuConectar.setName("menuConectar");
        menuConectar.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                menuConectarKeyPressed(evt);
            }
        });
        menuConectar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                menuConectarMouseClicked(evt);
            }
        });

        menu_Opcoes.add(menuConectar);

        menuDesconectar.setText("Desconectar");
        menuDesconectar.setName("menuDesconectar");
        menuDesconectar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuDesconectarActionPerformed(evt);
            }
        });
        menuDesconectar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                menuDesconectarMouseClicked(evt);
            }
        });

        menu_Opcoes.add(menuDesconectar);

        menu_Opcoes.add(jSeparator1);

        menuSair.setText("Sair");
        menuSair.setName("menuSair");
        menuSair.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                menuSairMouseClicked(evt);
            }
        });

        menu_Opcoes.add(menuSair);

        menu.add(menu_Opcoes);

        jFrame.setJMenuBar(menu);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(jFrame.getContentPane());
        jFrame.getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(painelTabs, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 599, Short.MAX_VALUE)
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(labelOnline, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 52, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(labelArqComp, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 99, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(labelServentsOnline, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(labelTransferencias, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 111, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botaoSair, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(12, 12, 12))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(labelArqComp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(labelServentsOnline, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(labelTransferencias, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, botaoSair, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(labelOnline, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(painelTabs, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 355, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jFrame.pack();
    }// </editor-fold>//GEN-END:initComponents

    private void botaoConectarKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_botaoConectarKeyPressed
// TODO add your handling code here:
			conectar();
    }//GEN-LAST:event_botaoConectarKeyPressed

    private void botaoConectarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoConectarMouseClicked
// TODO add your handling code here:
			conectar();
		}
		
		private void conectar()
		{
			try {
				if(colunaTabelaServents.isEmpty())
					LOG.info("Lista de servents vazia, adicione um novo servent para conectar");
				else
				if(tabelaServents.getSelectedRow() != -1) {
					String host = tabelaServents.getValueAt(tabelaServents.getSelectedRow(), 0).toString();
					int porta = Integer.parseInt(tabelaServents.getValueAt(tabelaServents.getSelectedRow(), 1).toString());
					conecta(host, porta);
				}else
					JOptionPane.showMessageDialog(null, "Selecione o host para conectar-se.");
			}
			catch(Exception conectar) {
				LOG.falha(" ao conectar no servent " + conectar.getMessage());
			}
    }
			
    private void botaoAtualizarTabelaArquivosKeyPressed(java.awt.event.KeyEvent evt)
		{
			if(repositorio.gera())
				LOG.info("Lista de arquivos compartilhados atualizada com sucesso!");
			else
				LOG.falha("Problemas ao atualizar lista de arquivos compartilhados!");
    }

    private void botaoAtualizarTabelaArquivosMouseClicked(java.awt.event.MouseEvent evt)
		{
			if(repositorio.gera())
				LOG.info("Lista de arquivos compartilhados atualizada com sucesso!");
			else
				LOG.falha("Problemas ao atualizar lista de arquivos compartilhados!");
    }

    private void botaoAumentarRedeKeyPressed(java.awt.event.KeyEvent evt)
		{
			if(!ping())
				LOG.falha("ao procurar novos servents");
    }

    private void botaoAumentarRedeMouseClicked(java.awt.event.MouseEvent evt)
		{
			if(Dados.onlineServents.tamanho() == 0)
					JOptionPane.showMessageDialog(null, "Voc no est conectado a rede gnutella");
			else
				if(!ping())
					LOG.falha("ao procurar novos servents");
		}

    private void menuSairMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_menuSairMouseClicked
// TODO add your handling code here:
        System.out.println("menu sair");
    }//GEN-LAST:event_menuSairMouseClicked

    private void menuDesconectarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_menuDesconectarMouseClicked
// TODO add your handling code here:
        System.out.println("menu descconectar");
    }//GEN-LAST:event_menuDesconectarMouseClicked

    private void tabelaBuscaMouseClicked(java.awt.event.MouseEvent evt)
		{
			String nomeArquivo = tabelaBusca.getValueAt(tabelaBusca.getSelectedRow(), 0).toString();
			int tamanho = Integer.parseInt(tabelaBusca.getValueAt(tabelaBusca.getSelectedRow(), 1).toString());
			int index = Integer.parseInt(tabelaBusca.getValueAt(tabelaBusca.getSelectedRow(), 2).toString());
			String host = tabelaBusca.getValueAt(tabelaBusca.getSelectedRow(), 3).toString();
			int porta = Integer.parseInt(tabelaBusca.getValueAt(tabelaBusca.getSelectedRow(), 4).toString());

			Thread download = new Thread(new ArquivoDownload(nomeArquivo, tamanho, index, host, porta));
			download.start();
			
			Vector novoDownload = new Vector();
			novoDownload.addElement(nomeArquivo);
			novoDownload.addElement(tamanho + "");
			novoDownload.addElement(index + "");
			novoDownload.addElement(host);
			novoDownload.addElement(porta + "");
			synchronized(linhaTabelaDownload) {
				linhaTabelaDownload.addElement(novoDownload);
			}
			synchronized(tabelaDownload) {
				tabelaDownload.addNotify();
			}
			Dados.download+=1;
			synchronized(labelTransferencias) {
				labelTransferencias.setText(Dados.download + "/" + Dados.upload);
			}
    }

    private void menuConectarMouseClicked(java.awt.event.MouseEvent evt)
		{
			System.out.println("menu conectar");
    }

    private void menuConectarKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_menuConectarKeyPressed
// TODO add your handling code here:
    }//GEN-LAST:event_menuConectarKeyPressed

    private void botaoBuscaMouseClicked(java.awt.event.MouseEvent evt)
		{
      buscar();
    }

    private void botaoBuscaKeyPressed(java.awt.event.KeyEvent evt)
		{
			buscar();
    }

		private void buscar()
		{
			try {
				if(Dados.onlineServents.tamanho() <=0)
					JOptionPane.showMessageDialog(null, "Voc no est conectado a rede gnutella");
				else {
					if(textBusca.getText().length() <= 0)
						JOptionPane.showMessageDialog(null, "Digite o termo para o qual deseja buscar.");
					else {
							synchronized(linhaTabelaBusca) {
								JanelaPrincipal.linhaTabelaBusca.clear();
							}
							synchronized(tabelaBusca) {
								tabelaBusca.addNotify();
							}
						query(0, textBusca.getText());
					}
				}
			}
			catch(Exception conectar) {
				LOG.falha(" ao clicar no botao de busca " + conectar.getMessage());
			}
    }
		
    private void textBuscaKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_textBuscaKeyTyped
// TODO add your handling code here:
    }//GEN-LAST:event_textBuscaKeyTyped

    private void textPortaKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_textPortaKeyTyped
// TODO add your handling code here:
    }//GEN-LAST:event_textPortaKeyTyped

    private void botaoConectaServentMouseClicked(java.awt.event.MouseEvent evt)
		{
			adicionaConectaServent();
    }

    private void botaoConectaServentKeyPressed(java.awt.event.KeyEvent evt) 
		{
			adicionaConectaServent();
    }

		private void adicionaConectaServent()
		{
			if(textIp.getText().length() > 8 && textPorta.getText().length() > 0)
			{
				String host = textIp.getText();
				int porta = Integer.parseInt(textPorta.getText());
				if(conecta(host, porta)) {
					textIp.setText("");
					textPorta.setText("");
				} else {
					Servent servent = new Servent(host, porta, 0, 0, "desconhecido");
					if(!Dados.offlineServents.existe(host)) {
						Dados.offlineServents.adiciona(servent);
						Dados.offlineServents.atualizaTabelaServents();
					}
					textIp.setText("");
					textPorta.setText("");
					JOptionPane.showMessageDialog(null, "No foi possivel conectar ao servent!\nAdicionado na lista de offline para futuras conexoes!");
				 }
			} else
				JOptionPane.showMessageDialog(null, "Verifique se o host ou a porta esto corretos!");
		}
		
    private void botaoDesconectarKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_botaoDesconectarKeyPressed
// TODO add your handling code here:
        desconectar();
    }//GEN-LAST:event_botaoDesconectarKeyPressed

    private void botaoDesconectarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoDescontarMouseClicked
// TODO add your handling code here:
        desconectar();
    }//GEN-LAST:event_botaoDescontarMouseClicked
		
		private void desconectar() {
			try {
				if(linhaTabelaServentsOnline.isEmpty())
					JOptionPane.showMessageDialog(null, "No h nenhum servent online!");
				else
				if(tabelaServentsOnline.getSelectedRow() != -1) {
					String host = tabelaServentsOnline.getValueAt(tabelaServentsOnline.getSelectedRow(), 0).toString();
					int porta = Integer.parseInt(tabelaServentsOnline.getValueAt(tabelaServentsOnline.getSelectedRow(), 1).toString());
					desconecta(host, porta);
				}else
					JOptionPane.showMessageDialog(null, "Selecione o host que deseja desconectar!");				
			}
			catch(Exception conectar) {
				LOG.falha(conectar.getMessage());
			}
		}

    private void botaoSairMouseClicked(java.awt.event.MouseEvent evt)
		{
			synchronized(Dados.onlineServents) {
				Dados.onlineServents.fechaConexoes();
			}
			synchronized(Dados.onlineClientes) {
				Dados.onlineClientes.fechaConexoes();
			}
			System.exit(0);
    }

    private void menuDesconectarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuDesconectarActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_menuDesconectarActionPerformed

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public static javax.swing.JButton botaoConectaServent;
    public static javax.swing.JButton botaoAtualizarTabelaArquivos;
    public static javax.swing.JButton botaoAumentarRede;
    public static javax.swing.JButton botaoBusca;
    public static javax.swing.JButton botaoConectar;
    public static javax.swing.JButton botaoDesconectar;
    public static javax.swing.JButton botaoSair;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    public static javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JSeparator jSeparator1;
    public static javax.swing.JLabel labelArqComp;
    public static javax.swing.JLabel labelOnline;
    public static javax.swing.JLabel labelServentsOnline;
    public static javax.swing.JLabel labelTransferencias;
    private javax.swing.JMenuBar menu;
    public static javax.swing.JMenuItem menuConectar;
    public static javax.swing.JMenuItem menuDesconectar;
    public static javax.swing.JMenuItem menuSair;
    private javax.swing.JMenu menu_Opcoes;
    private javax.swing.JTabbedPane painelTabs;
    public static javax.swing.JTabbedPane tabArquivosCompartilhados;
    private javax.swing.JTabbedPane tabBusca;
    private javax.swing.JTabbedPane tabLog;
    private javax.swing.JTabbedPane tabServents;
    private javax.swing.JTabbedPane tabSobre;
    private javax.swing.JTabbedPane tabTransferencias;
    public static javax.swing.JTable tabelaArquivosCompartilhados;
    public static javax.swing.JTable tabelaBusca;
    public static javax.swing.JTable tabelaDownload;
    private javax.swing.JScrollPane tabelaDownloads;
    public static javax.swing.JTable tabelaServents;
    public static javax.swing.JTable tabelaServentsOnline;
    public static javax.swing.JTable tabelaUploads;
    public static javax.swing.JTextArea textAreaLog;
    public static javax.swing.JTextField textBusca;
    public static javax.swing.JTextField textIp;
    public static javax.swing.JTextField textPorta;
    // End of variables declaration//GEN-END:variables
    
}
